// ignore_for_file: use_key_in_widget_constructors

import 'dart:async';
import 'dart:convert';
import 'dart:developer';
import 'dart:io';

import 'package:aretmis_cupps_runner/data.dart';
import 'package:artemis_cupps/artemis_cupps.dart';
import 'package:dart_ipify/dart_ipify.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:network_info_plus/network_info_plus.dart';
import 'screens/bc_device_screen.dart';
import 'screens/bp_device_screen.dart';
import 'screens/bt_device_screen.dart';
import 'screens/log_screen.dart';
import 'screens/pr_device_screen.dart';
import 'screens/oc_device_screen.dart';
import 'screens/ms_device_screen.dart';
import 'screens/zi_device_screen.dart';
import 'screens/zl_device_screen.dart';
import 'screens/be_device_screen.dart';
import 'screens/bg_device_screen.dart';
import 'screens/dd_device_screen.dart';

void main() {
  WidgetsFlutterBinding.ensureInitialized();
  runZonedGuarded(() {
    runApp(const MyApp());
  }, (error, stackTrace) {
    log('runZonedGuarded:  $error');
    // FirebaseCrashlytics.instance.recordError(error, stackTrace);
  });
}

class MyApp extends StatelessWidget {
  const MyApp({Key? key}) : super(key: key);

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return GetMaterialApp(
      title: 'Flutter Demo',
      debugShowCheckedModeBanner: false,
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.blue,
      ),
      home: MyHomePage(),
    );
  }
}

class MyHomePage extends StatefulWidget {
  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  PlatformDevices platformDevices = PlatformDevices.empty();
  TextEditingController ipC = TextEditingController(text: "192.168.1.248");
  TextEditingController portC = TextEditingController(text: "35000");
  bool platformConnect = false;

  bool loading = false;
  bool connecting = false;
  bool initing = false;
  bool initingAll = false;

  goToDeviceDetails(dynamic device) {
    switch (device.runtimeType) {
      case BpDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => BpDeviceScreen(device: device)));
        break;
      case BtDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => BtDeviceScreen(device: device)));
        break;
      case BcDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => BcDeviceScreen(device: device)));
        break;
      case BeDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => BeDeviceScreen(device: device)));
        break;
      case OcDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => OcDeviceScreen(device: device)));
        break;
      case MsDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => MsDeviceScreen(device: device)));
        break;
      case PrDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => PrDeviceScreen(device: device)));
        break;
      case BgDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => BgDeviceScreen(device: device)));
        break;
      case DdDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => DdDeviceScreen(device: device)));
        break;
      case ZlDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => ZlDeviceScreen(device: device)));
        break;
      case ZiDevice:
        Navigator.push(context, MaterialPageRoute(builder: (c) => ZiDeviceScreen(device: device)));
        break;
    }
  }

  @override
  void initState() {
    CUPPS.setDeviceTypes([
      DeviceType.bp,
      DeviceType.bg,
    ]);
    super.initState();
  }

  Future<bool> tryConnectSocket() async {
    String ip = "192.168.9.101";
    int port = 35000;
    try {
      // RawSocketOption option =RawSocketOption.fromBool(RawSocketOption.levelSocket,0x0008, true);
      // RawSocketOption option =RawSocketOption.fromInt(/* IPPROTO_TCP */ 6, /* TCP_KEEPALIVE */ 0x10, 5);
      // RawSocketOption option =RawSocketOption.fromInt(/* IPPROTO_TCP */ 1, /* TCP_KEEPALIVE */ 0x10, 5);
      RawSocketOption option = RawSocketOption.fromBool(/* SOL_SOCKET */ 0xffff, /* SO_KEEPALIVE */ 0x0008, true);
      // RawSocketOption option2 =RawSocketOption.fromInt(/* IPPROTO_TCP */ 6, /* TCP_KEEPALIVE */ 0x10, 10);
      // RawSocketOption option3 =RawSocketOption.fromInt(/* IPPROTO_TCP */ 9, /* TCP_KEEPALIVE */ 0x10, 4);
      // log("${RawSocketOption.IPv4MulticastInterface}");
      // log("${RawSocketOption.levelTcp}");
      // log("${RawSocketOption.levelSocket}");
      // log("${RawSocketOption.levelIPv4}");
      // log("${RawSocketOption.levelUdp}");

      if (Platform.isAndroid) {
        option = RawSocketOption.fromBool(/* SOL_SOCKET */ 0x1, /* SO_KEEPALIVE */ 0x0009, true);
      } else {
        // option = RawSocketOption.fromBool(/* SOL_SOCKET */ 0xffff, /* SO_KEEPALIVE */ 0x0008, true);
        option = RawSocketOption.fromBool(/* SOL_SOCKET */ 0xffff, /* SO_KEEPALIVE */ 0x0008, true);
      }
      // log("${option.level} ${option.option}");
      // log("${option2.level} ${option2.option}");

      SocketOption so = SocketOption.tcpNoDelay;
      Socket s = await Socket.connect(ip, 35000, timeout: const Duration(seconds: 10)).timeout(const Duration(seconds: 10),
          onTimeout: () {
        log("ERROR ON SOCKET TIMEOUT");
        return Socket.connect(ip, port);
      }).catchError((e) {
        log("ERROR ON SOCKET $e");
        return Socket.connect(ip, port);
      }).onError((error, stackTrace) {
        log("ERROR ON SOCKET $error");
        return Socket.connect(ip, port);
      }).then((value) {
        value.setRawOption(option);
        return value;
      });

      // s.getRawOption(option2);
      // s.setRawOption(option3);
      // s.setOption(so, true);
      // bool res =await s;

      log("DONE");
      // s.setRawOption(option2);
      s.listen((msg) {}, cancelOnError: false, onError: (e) {
        log("ERROR ON SOCKET $e");
        // disconnect();
      }, onDone: () {
        log("Socket DONE");
        // disconnect();
      });
      log("DONE");
      // _socket = s;
      return true;
    } catch (e) {
      Get.snackbar("Connection Error", e.toString());
      log("ERROR ON LISTENING TO SOCKET $e");
      return false;
    }
  }

  Future<void> connectToCupps() async {
    setState(() {
      connecting = true;
    });
    CUPPS
        .connectToPlatform(
            onPlatformDisconnect: () {
              // setState(() {
              //   platformDevices = PlatformDevices.empty();
              //   platformConnect = false;
              // });
              // Future.delayed(const Duration(seconds: 15),connectToCupps);
              // connectToCupps();
            },
            applicationVersion: "1.0.0.0",
            ip: ipC.text,
            port: int.tryParse(portC.text) ?? 0,
            airlineCode: "TK",
            notifier: () {
              setState(() {
                platformDevices = CUPPS().platformDevices;
              });
            },
            onPlatformConnectionChange: (bool v) {
              setState(() {
                platformConnect = v;
              });
            })
        .then((value) {
      setState(() {
        connecting = false;
      });
      if (value) {
        CUPPS.setConnectionChecker(
            interval: const Duration(seconds: 45),
            timeout: const Duration(seconds: 12),
            retryFunction: () async {
              log("CUPPS platform is not connected!");
              // await CUPPS.disconnectFromPlatform();
              connectToCupps();
            });
        setState(() {
          initing = true;
        });
        CUPPS.authenticate().then((value) {
          setState(() {
            initing = false;
          });
          if (value) {
            setState(() {
              initingAll = true;
            });
            CUPPS.connectToAvailableNeededDevices().then((value) {
              log("connectToAvailableNeededDevices Response:$value");
              setState(() {
                initingAll = false;
              });
            });
          }
        });
      } else {
        Future.delayed(const Duration(seconds: 30), () {
          connectToCupps();
        });
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    ThemeData theme = Theme.of(context);

    return Scaffold(
      appBar: AppBar(
        title: const Text("CUPPS"),
        actions: [
          IconButton(
              onPressed: () async {
                // String readerResXML = XMLExamples.readerReadResponseAbomisMS2;
                // ReaderReadResponse res = ReaderReadResponse.fromXML(readerResXML);
                // List<MsData> ms = res.dataList
                //     .map((e) => MsData.fromXML(e.data.toXML()))
                //     .toList();
                // log(ms.toString());

                // String readerResXML = XMLExamples.readerReadResponseAbomisOC2;
                // ReaderReadResponse res = ReaderReadResponse.fromXML(readerResXML);
                // List<OcData> oc = res.dataList.map((e) => OcData.fromXML(e.data.toXML())).toList();
                // log(jsonEncode(oc.map((e) => e.getParsedDate()).toList()));

                Navigator.push(context, MaterialPageRoute(builder: (c) => const LogScreen()));

                // XMLUtil.tryParseXML();
                // setState(() {
                //   loading = true;
                // });
                // await XMLUtil.waitWhile(() => XMLUtil().asyncDone).then((value) {
                //   print("here");
                //   setState(() {
                //     loading = false;
                //   });
                // });
              },
              icon: loading ? const Icon(Icons.send) : const Icon(Icons.bug_report_outlined))
        ],
      ),
      body: Column(
        children: [
          const Divider(),
          Container(
            padding: const EdgeInsets.symmetric(horizontal: 24),
            width: MediaQuery.of(context).size.width,
            color: Colors.white,
            child: Column(
              children: [
                platformConnect
                    ? Row(
                        children: [
                          Expanded(child: Text("Connected to ${ipC.text}:${portC.text}")),
                          TextButton(
                              onPressed: () async {
                                // setState(() {
                                //   platformConnect = false;
                                //   platformDevices = PlatformDevices.empty();
                                // });
                                CUPPS.disconnectFromPlatform();
                              },
                              child: const Text("Disconnect")),
                        ],
                      )
                    : Row(
                        children: [
                          Expanded(
                              flex: 4,
                              child: CupertinoTextField(
                                keyboardType: const TextInputType.numberWithOptions(signed: true, decimal: true),
                                controller: ipC,
                                placeholder: "ip e.g. 192.168.1.7",
                              )),
                          const SizedBox(width: 12),
                          Expanded(
                              flex: 2,
                              child: CupertinoTextField(
                                keyboardType: const TextInputType.numberWithOptions(signed: true),
                                controller: portC,
                                placeholder: "port e.g. 7535",
                              )),
                          const SizedBox(width: 12),
                          TextButton(
                              onPressed: () async {
                                // tryConnectSocket().then((value) {
                                //   print(value);
                                //   if (value) {}
                                // });
                                connectToCupps();
                              },
                              child: connecting ? const Text("...") : const Text("Connect")),
                        ],
                      ),
              ],
            ),
          ),
          const Divider(),
          Text("$initing"),
          Text("$initingAll"),
          const SizedBox(width: 12),

          TextButton(onPressed: () async {}, child: connecting ? const Text("...") : const Text("Get Status")),
          // TextButton(
          //     onPressed: () async {
          //       InterfaceLevelsAvailableRequest req = InterfaceLevelsAvailableRequest(messageID: 1, hsXsdVersion: "01.03");
          //
          //       final result = await SocketService.sendSocketMessage(req.toXML(), 1).timeout(Duration(seconds: 4), onTimeout: () {
          //         print("timeout");
          //         return "timeOut";
          //       });
          //       print(result);
          //     },
          //     child: const Text("Send")),
          const Divider(),
          Expanded(
              child: GridView(
            padding: const EdgeInsets.symmetric(horizontal: 12),
            gridDelegate:
                const SliverGridDelegateWithFixedCrossAxisCount(crossAxisCount: 3, crossAxisSpacing: 12, mainAxisSpacing: 12),
            children: platformDevices.bpDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () async {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList() +
                platformDevices.btDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList() +
                platformDevices.bcDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList() +
                platformDevices.bgDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList() +
                // platformDevices.beDevices
                //     .map((e) => DeviceWidget(
                //   device: e,
                //   onSelect: () {
                //     goToDeviceDetails(e);
                //   },
                // ))
                //     .toList() +
                // platformDevices.ddDevices
                //     .map((e) => DeviceWidget(
                //   device: e,
                //   onSelect: () {
                //     goToDeviceDetails(e);
                //   },
                // ))
                //     .toList() +
                platformDevices.msDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList() +
                platformDevices.prDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList() +
                // platformDevices.ziDevices
                //     .map((e) => DeviceWidget(
                //   device: e,
                //   onSelect: () {
                //     goToDeviceDetails(e);
                //   },
                // ))
                //     .toList() +
                // platformDevices.zlDevices
                //     .map((e) => DeviceWidget(
                //   device: e,
                //   onSelect: () {
                //     goToDeviceDetails(e);
                //   },
                // ))
                //     .toList() +
                platformDevices.ocDevices
                    .map((e) => DeviceWidget(
                          device: e,
                          onSelect: () {
                            goToDeviceDetails(e);
                          },
                        ))
                    .toList(),
          )),
          FutureBuilder(
              future: NetworkInfo().getWifiIP(),
              builder: (c, snapshot) {
                if (snapshot.connectionState == ConnectionState.done || snapshot.hasData) {
                  var data = snapshot.data;
                  return Text("Device local IP $data");
                }
                return const Text("Loading ip");
              }),
          FutureBuilder(
              future: Ipify.ipv4(),
              builder: (c, snapshot) {
                if (snapshot.connectionState == ConnectionState.done || snapshot.hasData) {
                  var data = snapshot.data;
                  return Text("Device Public IP $data");
                }
                return const Text("Loading ip");
              }),
        ],
      ),
    );
  }
}

class DeviceWidget extends StatelessWidget {
  final Device device;
  final Function onSelect;

  const DeviceWidget({required this.device, required this.onSelect});

  @override
  Widget build(BuildContext context) {
    ThemeData theme = Theme.of(context);
    return TextButton(
        onPressed: () {
          onSelect();
        },
        child: device.isPrinting ? Icon(Icons.print, size: 50) : Image.asset(device.icon, package: 'artemis_cupps'));
    // return
    //   Column(
    //   children: [
    //     ListTile(
    //       tileColor: device.deviceParameter.status.color,
    //       leading: Text("${device.deviceIndex} ${device.getType.name}"),
    //       trailing: Icon(Icons.circle, color: device.isConnected ? Colors.green : Colors.red),
    //       title: Text(device.deviceName),
    //       subtitle: Text("${device.deviceParameter.ipAndPort} ${device.deviceParameter.status}"),
    //     ),
    //     Row(
    //       mainAxisAlignment: MainAxisAlignment.spaceAround,
    //       children: [
    //         TextButton(
    //             onPressed: () {
    //               onConnect();
    //             },
    //             child: const Text("Connect")),
    //         TextButton(
    //             onPressed: () {
    //               initialize();
    //             },
    //             child: const Text("Initialize")),
    //         TextButton(onPressed: () {
    //           AeaRequestRequest req = AeaRequestRequest(text: DataExample.printAeaData);
    //           send(req.toXML());
    //         }, child: const Text("Send AEA")),
    //       ],
    //     )
    //   ],
    // );
  }
}

class Animated extends StatefulWidget {
  const Animated({Key? key}) : super(key: key);

  @override
  _AnimatedState createState() => _AnimatedState();
}

class _AnimatedState extends State<Animated> {
  int step = 0;

  @override
  Widget build(BuildContext context) {
    return Image.asset(
      "${AssetImages.iconsAddress}/bt/bt_printing.gif",
      package: 'artemis_cupps',
      width: 100,
      height: 100,
    );
  }
}
