import 'package:artemis_cupps/artemis_cupps.dart';
import '../../classes/notify.dart';
import 'package:xml/xml.dart';

class PAltEnteredEvent extends Notify {
  final String admin;
  final String message;

  PAltEnteredEvent({
    required int messageID,
    required String messageName,
    required this.admin,
    required this.message,
  }) : super(
            messageID: messageID, messageName: messageName, notificationType: NotificationType.unknown, name: "pAltEnteredEvent");

  factory PAltEnteredEvent.fromXML(String xmlSTR) {
    final document = XmlDocument.parse(xmlSTR);

    String messageName = document.rootElement.attributes.firstWhere((p0) => p0.name.toString() == "messageName").value;
    String messageID = document.rootElement.attributes.firstWhere((p0) => p0.name.toString() == "messageID").value;

    XmlElement eventElement = document.rootElement.findAllElements("pAltEnteredEvent").first;
    String admin = eventElement.attributes.firstWhere((p0) => p0.name.toString() == "admin", orElse: orElseEmpty).value;
    String message = eventElement.attributes.firstWhere((p0) => p0.name.toString() == "message", orElse: orElseEmpty).value;

    return PAltEnteredEvent(
      messageName: messageName,
      messageID: int.parse(messageID),
      admin: admin,
      message: message,
    );
  }

  @override
  String toXML() {
    return '''
    <?xml version="1.0" encoding="utf-8"?>
    <cupps xmlns="$xmlns" messageID="$messageID" xmlns:xsi="$xsi" messageName="$messageName">
        <notify>
            <pAltEnteredEvent admin="$admin" message="$message"/>
        </notify>
    </cupps>
    '''
        .replaceAll("\n", "")
        .replaceAll("\t", "")
        .replaceAll("  ", "");
  }

  @override
  String toString() {
    return "$messageID : $messageName ";
  }
}
