import 'package:xml/xml.dart';

import '../classes.dart';

class InterfaceLevelsAvailableRequest extends CuppsBase {
  final String hsXsdVersion;

  InterfaceLevelsAvailableRequest({
    required int messageID,
    String? xmlns,
    String? xsi,
    required this.hsXsdVersion,
  }) : super(
            messageID: messageID,
            messageName: "interfaceLevelsAvailableRequest");

  factory InterfaceLevelsAvailableRequest.fromXML(String xmlSTR) {
    final document = XmlDocument.parse(xmlSTR);
    document.findElements("messageName");
    String messageID = document.rootElement.attributes
        .firstWhere((p0) => p0.name.toString() == "messageID")
        .value;

    // String xmlns = document.rootElement.attributes.firstWhere((p0) => p0.name.toString() == "xmlns").value;
    String xsi = document.rootElement.attributes
        .firstWhere((p0) => p0.name.toString() == "xmlns:xsi")
        .value;
    String hsXsdVersion = document.rootElement.childElements.first.attributes
        .firstWhere((p0) => p0.name.toString() == "hsXsdVersion")
        .value;

    return InterfaceLevelsAvailableRequest(
        hsXsdVersion: hsXsdVersion,
        xsi: xsi,
        // xmlns: xmlns,
        messageID: int.parse(messageID));
  }

  @override
  String toXML() {
    return '''
    <?xml version="1.0" encoding="utf-8"?>
    <cupps messageID="$messageID" xmlns:xsi="$xsi" messageName="$messageName">
        <$messageName hsXsdVersion="$hsXsdVersion"/>
    </cupps>
    '''
        .replaceAll("\n", "")
        .replaceAll("\t", "")
        .replaceAll("  ", "");
  }

  @override
  String toString() {
    return "$messageID : $messageName : $xsi : $hsXsdVersion";
  }
}
