import 'package:xml/xml.dart';

import '../classes.dart';

class InterfaceLevelResponse extends CuppsBase {
  final String result;

  InterfaceLevelResponse({
    required this.result,
  }) : super(messageID: 2, messageName: "interfaceLevelResponse");

  factory InterfaceLevelResponse.fromXML(String xmlSTR) {
    final document = XmlDocument.parse(xmlSTR);
    document.findElements("messageName");

    String result = document.rootElement.childElements.first.attributes
        .firstWhere((p0) => p0.name.toString() == "result")
        .value;

    return InterfaceLevelResponse(
      result: result,
      // xsi: xsi,
    );
  }

  @override
  String toXML() {
    return '''
    <?xml version="1.0" encoding="utf-8"?>
    <cupps messageID="$messageID" xmlns:xsi="$xsi" messageName="$messageName">
        <$messageName result="$result"/>
    </cupps>
    '''
        .replaceAll("\n", "")
        .replaceAll("\t", "")
        .replaceAll("  ", "");
  }

  @override
  String toString() {
    return "$messageID : $messageName : $xsi : $result";
  }
}
